package com.censoft.censoftrongtong.utils;

import com.deepoove.poi.XWPFTemplate;
import com.deepoove.poi.config.Configure;
import com.deepoove.poi.data.ChartSingleSeriesRenderData;
import com.deepoove.poi.data.Charts;
import com.deepoove.poi.data.PictureRenderData;
import com.deepoove.poi.data.Pictures;

import javax.servlet.http.HttpServletResponse;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Test {
    private static final String IMAGE_PATH = "C:\\Users\\xjc\\Desktop\\上传照片\\风景图\\";
    public static void main(String[] args) throws IOException {
//        System.out.println(Convert.toStr(1));
//        System.out.println(DateUtil.now());
//        System.out.println(DateUtil.ageOfNow("1987-04-23"));
//
//        BufferedInputStream in = FileUtil.getInputStream("d:/source.txt");
//        BufferedOutputStream out = FileUtil.getOutputStream("d:/copyTo.txt");
//        long copySize = IoUtil.copy(in, out, IoUtil.DEFAULT_BUFFER_SIZE);
//        FileReader fileReader = new FileReader("d:/copyTo.txt");
//        String result = fileReader.readString();
//        System.out.println(result);
//
//        FileWriter writer = new FileWriter("d:/copyTo.txt");
//        writer.write("test");
//
//        FileReader fileReader1 = new FileReader("d:/copyTo.txt");
//        String result1 = fileReader1.readString();
//        System.out.println(result1);
//
//        System.out.println(CollUtil.join(CollUtil.newArrayList("a,b,c,d".split(",")),"#"));
//
//        List list = new ArrayList();
//        list.add("");
//        System.out.println(list.size());
//
//        //map
//        Map<String,String> map=new HashMap<String, String>();
//        map.put("aa","nn");
//        String ss="aa";
//        if (ss.contains("a")) {
//            System.out.println("闹喊");
//        }

//        List<String> list= ListUtil.toList("a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t".split(","));
//
//
//        for (int i = 0; i < list.size(); i++) {
//
//            String aa=list.get(i);
//
//            if(aa.equals("a")||aa.equals("d")){
//                aa=list.get(i+1);
//                i++;
//            }
//            String bb=list.get(i+1);
//            if(bb.equals("a")||bb.equals("d")){
//               bb=list.get(i+1);
//               i++;
//            }
//            i++;
//            System.out.println(aa+"--"+bb);
//        }

        /**
         * word渲染
         */
        //创建行循环策略
        MyLoopRowTableRenderPolicy rowTableRenderPolicy = new MyLoopRowTableRenderPolicy();
//告诉模板引擎，要在students做行循环,绑定行循环策略
        Configure configure = Configure.builder().bind("students", rowTableRenderPolicy).build();
//创建目标文件
        File sourceFile = new File("G:\\VideoTest\\renderwordtemplate.docx");
//构建数据
        Map<String, Object> data = new HashMap();

//1.学生数据
        List<Student> students = new ArrayList<>();
        Student s1 = new Student("小明", "001", "2022-09-01");
        Student s2 = new Student("小红", "002", "2022-09-02");
        students.add(s1);
        students.add(s2);
//2.设置到students字段中
        data.put("students", students);
/**
 * 加入echarts图
 */
        ChartSingleSeriesRenderData demo1 = Charts.ofPie3D("", new String[]{"第一季度", "第二季度", "第三季度", "第四季度"})
                .series("", new Number[]{0.3, 0.3, 0.2, 0.2})
                .create();
        data.put("demo1", demo1);
/**
 * 插入图片
  */

        List<Map<String, PictureRenderData>> pictureList = createPictureList(240, 240);
        data.put("pictures", pictureList);
//创建输出流
        OutputStream os = new FileOutputStream("G:\\VideoTest\\renderwordresult.docx");
//最终编译渲染并输出
        XWPFTemplate.compile(sourceFile,configure).render(data).writeAndClose(os);


    }
    private static List<Map<String, PictureRenderData>> createPictureList(int width, int height) {
        List<Map<String, PictureRenderData>> list = new ArrayList<>();

        list.add(createPictureMap("pexels-asad-photo-maldives-1450340.jpg", width, height));
        list.add(createPictureMap("pexels-bob-clark-21492.jpg", width, height));

        return list;
    }

    private static Map<String, PictureRenderData> createPictureMap(String imageName, int width, int height) {
        Map<String, PictureRenderData> map = new HashMap<>();
        map.put("picture", Pictures.ofLocal(IMAGE_PATH + imageName).size(width, height).create());
        return map;
    }

    private void setResponseHeader(HttpServletResponse response) {
        response.reset();
        response.setContentType("application/octet-stream");
        response.setHeader("Content-disposition",
                "attachment;filename=user_word_" + System.currentTimeMillis() + ".docx");
    }

}
